class_name Salute
extends Node2D


const FLASH = preload("res://entity/flash/flash.tscn")

export var spawn_pause := 0.5
export var cheat_spawn_pause := 0.7
export var spawn_limit := 3
export var active := false setget set_active, get_active

var _spawn_elasped := 0.0
var _cheat_spawn_elasped := 0.0
var _cheat := []
var _reset_played := false


func _ready() -> void:
	randomize()


func _process(delta: float) -> void:
	if not _cheat.empty():
		_cheat_spawn_elasped += delta
		if _cheat_spawn_elasped >= cheat_spawn_pause:
			_cheat_spawn_elasped = 0.0
			_cheat_spawn_flash()
	if active:
		_spawn_elasped += delta
		if _spawn_elasped >= spawn_pause:
			_spawn_elasped = 0.0
			for _i in spawn_limit:
				_spawn_flash()


func set_active(value: bool) -> void:
	active = value


func get_active() -> bool:
	return active


func play_cheat(combination: int) -> void:
	_reset_played = false
	_cheat_spawn_elasped = 0.0
	_cheat.clear()
	while combination > 0:
		_cheat.append(combination % 10)
		combination /= 10


func _spawn_flash() -> void:
	var flash: Flash = FLASH.instance()
	var size: Vector2 = flash.SPRITE_SIZE
	var limit_x: float = get_viewport().size.x / 2 - size.x * 1.2
	var limit_y: float = get_viewport().size.y / 2 - size.y * 1.2
	flash.position.x = rand_range(-limit_x, limit_x)
	flash.position.y = rand_range(-limit_y, limit_y)
	add_child(flash)


func _cheat_spawn_flash() -> void:
	var flash: Flash = FLASH.instance()
	if not _reset_played:
		flash.position.y = get_viewport().size.y / 4 * -1
		_reset_played = true
	else:
		var digit: int = _cheat.pop_back()
		var x4: float = get_viewport().size.x / 4
		var y4: float = get_viewport().size.y / 4
		match digit:
			1:
				flash.position.x = (x4 + (x4 / 2)) * -1
				flash.position.y = (y4 - (y4 / 2))
			2:
				flash.position.x = (x4 + (x4 / 2))
				flash.position.y = (y4 - (y4 / 2))
			3:
				flash.position.x = (x4 + (x4 / 2)) * -1
				flash.position.y = (y4 + (y4 / 2))
			4:
				flash.position.x = (x4 + (x4 / 2))
				flash.position.y = (y4 + (y4 / 2))
	add_child(flash)
