extends Object


enum Variant {
	STANDARD,
	ST_1,
	ST_2,
	ST_3,
	ST_4,
	ST_5,
	ST_6,
	ST_7,
	ST_8,
	GUN,
	GUN_FLAT,
	GUN_RED,
	GUN_BLUE,
}

var standard := {
	"impulse_min": 200.0,
	"impulse_max": 1000.0,
	"texture": "standard",
}
var standard_1
var standard_2
var standard_3
var standard_4
var standard_5
var standard_6
var standard_7
var standard_8
var gun := {
	"impulse_min": 100.0,
	"impulse_max": 500.0,
	"texture": "gun",
}
var gun_flat := {
	"impulse_min": 200.0,
	"impulse_max": 600.0,
	"texture": "gun_flat",
}
var gun_red := {
	"impulse_min": 200.0,
	"impulse_max": 400.0,
	"texture": "gun_red",
}
var gun_blue := {
	"impulse_min": 200.0,
	"impulse_max": 700.0,
	"texture": "gun_blue",
}


func _init() -> void:
	randomize()
	for i in range(1, 9):
		self.set("standard_" + str(i), {
				"impulse_min": rand_range(200.0, 300.0),
				"impulse_max": rand_range(600.0, 1000.0),
				"texture": "st_" + str(i),
		})


func get_vars(variant) -> Dictionary:
	match variant:
		Variant.STANDARD:
			return standard
		Variant.ST_1:
			return standard_1
		Variant.ST_2:
			return standard_2
		Variant.ST_3:
			return standard_3
		Variant.ST_4:
			return standard_4
		Variant.ST_5:
			return standard_5
		Variant.ST_6:
			return standard_6
		Variant.ST_7:
			return standard_7
		Variant.ST_8:
			return standard_8
		Variant.GUN:
			return gun
		Variant.GUN_FLAT:
			return gun_flat
		Variant.GUN_RED:
			return gun_red
		Variant.GUN_BLUE:
			return gun_blue
		_:
			return standard
