extends Object


enum Variant {
	STANDARD,
	STANDARD_NEWBIE,
	STANDARD_FAST,
	STANDARD_WHITE_BLUE,
	FLAT,
	FLAT_BLUE,
	FLAT_GRAY,
	FLAT_SW_BLUE,
	RED,
	RED_RED,
	RED_LIGHT,
	#
	RED_STANDARD,
	RED_BLUE,
	RED_WHITE_BLUE,
	RED_BIG_BLUE,
	RED_GRAY,
	RED_SMALL_WHITE_BLUE,
	RED_SMALL_WHITE_BLUE_1,
	RED_SMALL_WHITE_BLUE_2,
	RED_YELLOW,
	#
	BLUE,
	BLUE_WYELLOW,
	BLUE_WYELLOW_FAST,
	BLUE_BLUE,
	BLUE_LIGHT_BLUE,
	BLUE_LIGHT_BLUE_1,
	BLUE_WBLUE,
}
enum Type {
	STANDARD,
	FLAT,
	RED,
	BLUE,
}

#
# STANDARD
#

var standard := {
	"type": Type.STANDARD,
	"rotate_speed": 1.5,
	"bullets_spawn_interval": 0.4,
	"bullets_variant": Bullet.Variants.Variant.STANDARD,
	# don't change hp, it's set for `damaged` sprites amount (see `_on_hp_change` in gun.gd)
	"hp": 4.0,
	"damage": 1.5,
	"texture": "standard",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN,
}
var standard_newbie := {
	"type": Type.STANDARD,
	"rotate_speed": 1.5,
	"bullets_spawn_interval": 0.35,
	"bullets_variant": Bullet.Variants.Variant.STANDARD,
	"hp": 4.0,
	"damage": 1.5,
	"texture": "standard",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN,
}
var standard_fast := {
	"type": Type.STANDARD,
	"rotate_speed": 2.0,
	"bullets_spawn_interval": 0.14,
	"bullets_variant": Bullet.Variants.Variant.SMALL_WHITE_BLUE_2,
	"hp": 4.0,
	"damage": 1.5,
	"texture": "standard",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN,
}
var standard_white_blue := {
	"type": Type.STANDARD,
	"rotate_speed": 1.5,
	"bullets_spawn_interval": 0.4,
	"bullets_variant": Bullet.Variants.Variant.WHITE_BLUE,
	"hp": 4.0,
	"damage": 1.5,
	"texture": "standard",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN,
}

#
# FLAT
#

var flat := {
	"type": Type.FLAT,
	"rotate_speed": 2.5,
	"bullets_spawn_interval": 0.2,
	"bullets_variant": Bullet.Variants.Variant.BIG_BLUE,
	"hp": 3.0,
	"damage": 1.0,
	"texture": "flat",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_FLAT,
}
var flat_blue := {
	"type": Type.FLAT,
	"rotate_speed": 2.5,
	"bullets_spawn_interval": 0.25,
	"bullets_variant": Bullet.Variants.Variant.BLUE,
	"hp": 3.0,
	"damage": 1.0,
	"texture": "flat",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_FLAT,
}
var flat_gray := {
	"type": Type.FLAT,
	"rotate_speed": 2.0,
	"bullets_spawn_interval": 0.35,
	"bullets_variant": Bullet.Variants.Variant.GRAY,
	"hp": 3.0,
	"damage": 1.0,
	"texture": "flat",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_FLAT,
}
var flat_sw_blue := {
	"type": Type.FLAT,
	"rotate_speed": 2.1,
	"bullets_spawn_interval": 0.3,
	"bullets_variant": Bullet.Variants.Variant.SMALL_WHITE_BLUE,
	"hp": 3.0,
	"damage": 1.0,
	"texture": "flat",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_FLAT,
}

#
# RED
#

var red := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.7,
	"bullets_variant": Bullet.Variants.Variant.BIG_GREEN,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}
var red_red := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.4,
	"bullets_variant": Bullet.Variants.Variant.BIG_RED,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}
var red_light := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.35,
	"bullets_variant": Bullet.Variants.Variant.SMALL_WHITE_LIGHT_BLUE,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}
var red_standard := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.24,
	"bullets_variant": Bullet.Variants.Variant.STANDARD,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}
var red_blue := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.27,
	"bullets_variant": Bullet.Variants.Variant.BLUE,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}
var red_white_blue := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.35,
	"bullets_variant": Bullet.Variants.Variant.WHITE_BLUE,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}
var red_big_blue := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.35,
	"bullets_variant": Bullet.Variants.Variant.BIG_BLUE,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}
var red_gray := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.25,
	"bullets_variant": Bullet.Variants.Variant.GRAY,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}
var red_small_white_blue := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.25,
	"bullets_variant": Bullet.Variants.Variant.SMALL_WHITE_BLUE,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}
var red_small_white_blue_1 := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.3,
	"bullets_variant": Bullet.Variants.Variant.SMALL_WHITE_BLUE_1,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}
var red_small_white_blue_2 := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.3,
	"bullets_variant": Bullet.Variants.Variant.SMALL_WHITE_BLUE_2,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}
var red_yellow := {
	"type": Type.RED,
	"rotate_speed": 1.0,
	"bullets_spawn_interval": 0.32,
	"bullets_variant": Bullet.Variants.Variant.WHITE_YELLOW,
	"hp": 9.0,
	"damage": 3.0,
	"texture": "red",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_RED,
}

#
# BLUE
#

var blue := {
	"type": Type.BLUE,
	"rotate_speed": 2.0,
	"bullets_spawn_interval": 0.25,
	"bullets_variant": Bullet.Variants.Variant.SMALL_WHITE_BLUE_1,
	"hp": 5.0,
	"damage": 2.0,
	"texture": "blue",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_BLUE,
}
var blue_wyellow := {
	"type": Type.BLUE,
	"rotate_speed": 2.2,
	"bullets_spawn_interval": 0.23,
	"bullets_variant": Bullet.Variants.Variant.WHITE_YELLOW,
	"hp": 5.0,
	"damage": 2.0,
	"texture": "blue",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_BLUE,
}
var blue_wyellow_fast := {
	"type": Type.BLUE,
	"rotate_speed": 2.3,
	"bullets_spawn_interval": 0.21,
	"bullets_variant": Bullet.Variants.Variant.WHITE_YELLOW,
	"hp": 5.0,
	"damage": 2.0,
	"texture": "blue",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_BLUE,
}
var blue_blue := {
	"type": Type.BLUE,
	"rotate_speed": 2.1,
	"bullets_spawn_interval": 0.26,
	"bullets_variant": Bullet.Variants.Variant.BLUE,
	"hp": 5.0,
	"damage": 2.0,
	"texture": "blue",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_BLUE,
}
var blue_light_blue := {
	"type": Type.BLUE,
	"rotate_speed": 2.2,
	"bullets_spawn_interval": 0.23,
	"bullets_variant": Bullet.Variants.Variant.SMALL_WHITE_BLUE,
	"hp": 5.0,
	"damage": 2.0,
	"texture": "blue",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_BLUE,
}
var blue_light_blue_1 := {
	"type": Type.BLUE,
	"rotate_speed": 2.2,
	"bullets_spawn_interval": 0.23,
	"bullets_variant": Bullet.Variants.Variant.SMALL_WHITE_BLUE_1,
	"hp": 5.0,
	"damage": 2.0,
	"texture": "blue",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_BLUE,
}
var blue_wblue := {
	"type": Type.BLUE,
	"rotate_speed": 2.0,
	"bullets_spawn_interval": 0.25,
	"bullets_variant": Bullet.Variants.Variant.WHITE_BLUE,
	"hp": 5.0,
	"damage": 2.0,
	"texture": "blue",
	"fragments_min": 2,
	"fragments_max": 5,
	"fragments_variant": Fragment.Variants.Variant.GUN_BLUE,
}


func get_vars(variant) -> Dictionary:
	match variant:
		Variant.STANDARD:
			return standard
		Variant.STANDARD_NEWBIE:
			return standard_newbie
		Variant.STANDARD_FAST:
			return standard_fast
		Variant.STANDARD_WHITE_BLUE:
			return standard_white_blue
		Variant.FLAT:
			return flat
		Variant.FLAT_BLUE:
			return flat_blue
		Variant.FLAT_GRAY:
			return flat_gray
		Variant.FLAT_SW_BLUE:
			return flat_sw_blue
		Variant.RED:
			return red
		Variant.RED_RED:
			return red_red
		Variant.RED_LIGHT:
			return red_light
		Variant.RED_STANDARD:
			return red_standard
		Variant.RED_BLUE:
			return red_blue
		Variant.RED_WHITE_BLUE:
			return red_white_blue
		Variant.RED_BIG_BLUE:
			return red_big_blue
		Variant.RED_GRAY:
			return red_gray
		Variant.RED_SMALL_WHITE_BLUE:
			return red_small_white_blue
		Variant.RED_SMALL_WHITE_BLUE_1:
			return red_small_white_blue_1
		Variant.RED_SMALL_WHITE_BLUE_2:
			return red_small_white_blue_2
		Variant.RED_YELLOW:
			return red_yellow
		Variant.BLUE:
			return blue
		Variant.BLUE_WYELLOW:
			return blue_wyellow
		Variant.BLUE_WYELLOW_FAST:
			return blue_wyellow_fast
		Variant.BLUE_BLUE:
			return blue_blue
		Variant.BLUE_LIGHT_BLUE:
			return blue_light_blue
		Variant.BLUE_LIGHT_BLUE_1:
			return blue_light_blue_1
		Variant.BLUE_WBLUE:
			return blue_wblue
		_:
			return standard
