extends Object


enum Variant {
	STANDARD,
	ST_1,
	ST_2,
	ST_3,
	ST_4,
	ST_5,
	ST_6,
	ST_7,
	ST_8,
	ST_9,
	ST_10,
	ST_11,
	ST_12,
	ST_13,
	ST_14,
	ST_15,
	ST_16,
	BIG_0,
	BIG_1,
	BIG_2,
	BIG_3,
	BIG_4,
	BIG_5,
	BIG_6,
	BIG_7,
}

var standard := {
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 2000.0,
	"impulse_min": 10.0,
	"impulse_max": 100.0,
	"hp": 1.0,
	"damage": 1.0,
	"mass": 10.0,
	"animation": "standard",
	"fragments": [
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.STANDARD },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_1 },
	],
}
var st_1 := {
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 2100.0,
	"impulse_min": 5.0,
	"impulse_max": 90.0,
	"hp": 1.0,
	"damage": 1.0,
	"mass": 10.0,
	"animation": "st_1",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_1 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_2 },
	],
}
var st_2 := {
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 2100.0,
	"impulse_min": 20.0,
	"impulse_max": 95.0,
	"hp": 1.0,
	"damage": 1.0,
	"mass": 10.0,
	"animation": "st_2",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_3 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_4 },
	],
}
var st_3 := {
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 2100.0,
	"impulse_min": 10.0,
	"impulse_max": 100.0,
	"hp": 1.0,
	"damage": 1.0,
	"mass": 10.0,
	"animation": "st_3",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_3 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_4 },
	],
}
var st_4 := {
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 1900.0,
	"impulse_min": 10.0,
	"impulse_max": 90.0,
	"hp": 1.0,
	"damage": 1.0,
	"mass": 10.0,
	"animation": "st_4",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_6 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_8 },
	],
}
var st_5 := {
	# fast
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 1700.0,
	"impulse_min": 120.0,
	"impulse_max": 160.0,
	"hp": 1.0,
	"damage": 1.5,
	"mass": 15.0,
	"animation": "st_5",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_2 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_6 },
	],
}
var st_6 := {
	# fast
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 1800.0,
	"impulse_min": 130.0,
	"impulse_max": 170.0,
	"hp": 1.0,
	"damage": 1.5,
	"mass": 17.0,
	"animation": "st_6",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_1 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_2 },
	],
}
var st_7 := {
	# slow
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 1500.0,
	"impulse_min": 10.0,
	"impulse_max": 50.0,
	"hp": 1.0,
	"damage": 0.5,
	"mass": 4.0,
	"animation": "st_7",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_3 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_4 },
	],
}
var st_8 := {
	"rotate_impulse_min": 150.0,
	"rotate_impulse_max": 2400.0,
	"impulse_min": 20.0,
	"impulse_max": 95.0,
	"hp": 1.0,
	"damage": 0.7,
	"mass": 3.0,
	"animation": "st_8",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_1 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_8 },
	],
}
var st_9 := {
	# strong
	"rotate_impulse_min": 10.0,
	"rotate_impulse_max": 2000.0,
	"impulse_min": 30.0,
	"impulse_max": 60.0,
	"hp": 3.0,
	"damage": 2.5,
	"mass": 35.0,
	"animation": "st_9",
	"fragments": [
			{ "min": 1, "max": 1, "variant": Fragment.Variants.Variant.ST_3 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_4 },
	],
}
var st_10 := {
	# faster
	"rotate_impulse_min": 100.0,
	"rotate_impulse_max": 1500.0,
	"impulse_min": 180.0,
	"impulse_max": 260.0,
	"hp": 1.0,
	"damage": 1.5,
	"mass": 7.0,
	"animation": "st_10",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_2 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_6 },
	],
}
var st_11 := {
	# fastest
	"rotate_impulse_min": 50.0,
	"rotate_impulse_max": 1900.0,
	"impulse_min": 270.0,
	"impulse_max": 320.0,
	"hp": 1.0,
	"damage": 1.7,
	"mass": 5.0,
	"animation": "st_11",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_1 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_2 },
	],
}
var st_12 := {
	# slow
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 1400.0,
	"impulse_min": 10.0,
	"impulse_max": 40.0,
	"hp": 1.0,
	"damage": 0.7,
	"mass": 20.0,
	"animation": "st_12",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_1 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_8 },
	],
}
var st_13 := {
	# stronger
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 2200.0,
	"impulse_min": 25.0,
	"impulse_max": 100.0,
	"hp": 4.0,
	"damage": 3.5,
	"mass": 60.0,
	"animation": "st_13",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_3 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_5 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_7 },
	],
}
var st_14 := {
	# strong
	"rotate_impulse_min": 40.0,
	"rotate_impulse_max": 1900.0,
	"impulse_min": 30.0,
	"impulse_max": 90.0,
	"hp": 3.0,
	"damage": 1.5,
	"mass": 20.0,
	"animation": "st_14",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_3 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_4 },
	],
}
var st_15 := {
	"rotate_impulse_min": 500.0,
	"rotate_impulse_max": 2400.0,
	"impulse_min": 10.0,
	"impulse_max": 110.0,
	"hp": 1.0,
	"damage": 1.5,
	"mass": 4.0,
	"animation": "st_15",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_2 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_8 },
	],
}
var st_16 := {
	# slow
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 1500.0,
	"impulse_min": 20.0,
	"impulse_max": 30.0,
	"hp": 1.0,
	"damage": 3.0,
	"mass": 40.0,
	"animation": "st_16",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_3 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_7 },
	],
}
var big_0 := {
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 2100.0,
	"impulse_min": 10.0,
	"impulse_max": 100.0,
	"hp": 6.0,
	"damage": 3,
	"mass": 80.0,
	"animation": "big_0",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_3 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_4 },
	],
}
var big_1 := {
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 1600.0,
	"impulse_min": 10.0,
	"impulse_max": 90.0,
	"hp": 8.0,
	"damage": 4.5,
	"mass": 120.0,
	"animation": "big_1",
	"fragments": [
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_3 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_4 },
	],
}
var big_2 := {
	# fast
	"rotate_impulse_min": 100.0,
	"rotate_impulse_max": 2700.0,
	"impulse_min": 50.0,
	"impulse_max": 130.0,
	"hp": 6.0,
	"damage": 3.5,
	"mass": 120.0,
	"animation": "big_2",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_1 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_8 },
	],
}
var big_3 := {
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 2200.0,
	"impulse_min": 30.0,
	"impulse_max": 80.0,
	"hp": 8.0,
	"damage": 3,
	"mass": 130.0,
	"animation": "big_3",
	"fragments": [
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_4 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_7 },
	],
}
var big_4 := {
	# slow
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 1300.0,
	"impulse_min": 5.0,
	"impulse_max": 50.0,
	"hp": 6.0,
	"damage": 2,
	"mass": 90.0,
	"animation": "big_4",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_2 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_6 },
	],
}
var big_5 := {
	# hard
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 1900.0,
	"impulse_min": 30.0,
	"impulse_max": 100.0,
	"hp": 12.0,
	"damage": 5,
	"mass": 220.0,
	"animation": "big_5",
	"fragments": [
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_4 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_5 },
	],
}
var big_6 := {
	# harder
	"rotate_impulse_min": 100.0,
	"rotate_impulse_max": 2100.0,
	"impulse_min": 15.0,
	"impulse_max": 80.0,
	"hp": 14.0,
	"damage": 6,
	"mass": 240.0,
	"animation": "big_6",
	"fragments": [
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_1 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_2 },
			{ "min": 1, "max": 2, "variant": Fragment.Variants.Variant.ST_6 },
	],
}
var big_7 := {
	# faster
	"rotate_impulse_min": 0.0,
	"rotate_impulse_max": 1800.0,
	"impulse_min": 70.0,
	"impulse_max": 160.0,
	"hp": 6.0,
	"damage": 3,
	"mass": 120.0,
	"animation": "big_7",
	"fragments": [
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_5 },
			{ "min": 1, "max": 3, "variant": Fragment.Variants.Variant.ST_7 },
	],
}


func get_vars(variant) -> Dictionary:
	match variant:
		Variant.STANDARD:
			return standard
		Variant.ST_1:
			return st_1
		Variant.ST_2:
			return st_2
		Variant.ST_3:
			return st_3
		Variant.ST_4:
			return st_4
		Variant.ST_5:
			return st_5
		Variant.ST_6:
			return st_6
		Variant.ST_7:
			return st_7
		Variant.ST_8:
			return st_8
		Variant.ST_9:
			return st_9
		Variant.ST_10:
			return st_10
		Variant.ST_11:
			return st_11
		Variant.ST_12:
			return st_12
		Variant.ST_13:
			return st_13
		Variant.ST_14:
			return st_14
		Variant.ST_15:
			return st_15
		Variant.ST_16:
			return st_16
		Variant.BIG_0:
			return big_0
		Variant.BIG_1:
			return big_1
		Variant.BIG_2:
			return big_2
		Variant.BIG_3:
			return big_3
		Variant.BIG_4:
			return big_4
		Variant.BIG_5:
			return big_5
		Variant.BIG_6:
			return big_6
		Variant.BIG_7:
			return big_7
		_:
			return standard
