extends Object


const BULLET = preload("res://entity/bullet/bullet.tscn")
const _LIMIT := 20

var _thread: Thread = Thread.new()
var _mutex: Mutex = Mutex.new()
var _cache := []


func fill() -> void:
	if _thread.is_alive():
		return
	if _thread.is_active():
		_thread.wait_to_finish()
		_thread = Thread.new()
	_thread.start(self, "_fill_cache")


func pop() -> Bullet:
	var bullet: Bullet
	_mutex.lock()
	if _cache.empty():
		bullet = BULLET.instance()
	else:
		bullet = _cache.pop_front()
	_mutex.unlock()
	return bullet


func clear() -> void:
	_mutex.lock()
	for bullet in _cache:
		bullet.queue_free()
	_cache.clear()
	_mutex.unlock()


func wait_thread() -> void:
	if _thread.is_active():
		_thread.wait_to_finish()


func _fill_cache() -> void:
	for _i in range(_LIMIT - _cache.size()):
		var bullet: Bullet = BULLET.instance()
		_mutex.lock()
		_cache.append(bullet)
		_mutex.unlock()
