extends Object


signal cheat_combination

const TIMEOUT := 5000
const ZEN_ENDLESS_LEVEL := 1423

var _numbers := []
var _cheats := {
	1234: "debug_info",
	1143: "next_bg_music",
	2143: "reset_actions",
	2241: "game_over",
	4331: "test_level",
	3241: "zen_level",
	ZEN_ENDLESS_LEVEL: "zen_endless_level",
}


func touch(viewport: Vector2, point: Vector2) -> void:
	if point.y < 0:
		_numbers.clear()
		return
	var top := false if abs(point.y) > viewport.y / 4 else true
	var left: bool = true if point.x < 0 else false
	var result: int = 0
	if top and left:
		result = 1
	elif top and not left:
		result = 2
	elif not top and left:
		result = 3
	elif not top and not left:
		result = 4
	if result == 0:
		_numbers.clear()
		return
	_numbers.append({
			"time": OS.get_ticks_msec(),
			"number": result,
	})
	_clear_expired_numbers()
	_calc()


func _clear_expired_numbers() -> void:
	var for_remove := []
	var time: int = OS.get_ticks_msec()
	for num in _numbers:
		if time - num.time > TIMEOUT:
			for_remove.append(num)
	for num in for_remove:
		_numbers.erase(num)


func _calc() -> void:
	var test: int = 0
	for num in _numbers:
		test += num.number
		test *= 10
	test /= 10
	if _cheats.has(test):
		_numbers.clear()
		emit_signal("cheat_combination", _cheats[test])
