extends Object


var _drops := []
var _amount_yellow := 0
var _amount_red := 0
var _amount_blue := 0


func get_next_variant(yellow: int, red: int, blue: int):
	if _amount_yellow < yellow:
		return Drop.DropVariant.YELLOW
	elif _amount_red < red:
		return Drop.DropVariant.RED
	elif _amount_blue < blue:
		return Drop.DropVariant.BLUE
	else:
		return Drop.DropVariant.NONE


func add_drop(drop: Drop) -> void:
	_drops.append(drop)
	_count(drop)


func remove_drop(drop: Drop) -> void:
	_drops.erase(drop)
	match(drop.get_variant()):
		Drop.DropVariant.YELLOW:
			_amount_yellow -= 1
		Drop.DropVariant.RED:
			_amount_red -= 1
		Drop.DropVariant.BLUE:
			_amount_blue -= 1


func iterate(obj: Object, method: String) -> void:
	for drop in _drops:
		obj.call(method, drop)


func recount() -> void:
	_amount_yellow = 0
	_amount_red = 0
	_amount_blue = 0
	for drop in _drops:
		_count(drop)


func clear() -> void:
	_drops.clear()


func _count(drop: Drop) -> void:
	match(drop.get_variant()):
		Drop.DropVariant.YELLOW:
			_amount_yellow += 1
		Drop.DropVariant.RED:
			_amount_red += 1
		Drop.DropVariant.BLUE:
			_amount_blue += 1
