class_name Events
extends Object


enum EventType {
	WARNING,
	METEORS_WAVE,
	GIFT,
	GUN_UPGRADE,
}
enum EventVariant {
	GIFT_BORDER,
	GIFT_DROP,
	GIFT_FLING,
	GIFT_RANDOM,
	GIFT_RENEWAL,
	GIFT_BOOST,
	GIFT_BORDER_05,
	GIFT_DROP_05,
	GIFT_FLING_05,
	GIFT_RANDOM_05,
	GIFT_RENEWAL_05,
	GIFT_BOOST_05,
	ALARM_5,
	ALARM_10,
	ALARM_15,
	ALARM_20,
	TEST_WAVE,
	TEST_UPGRADE,
	NEWBIE_WAVE,
	NEWBIE_WAVE_MANY,
	NEWBIE_UPGRADE_15,
	NEWBIE_UPGRADE_GUN,
	NEWBIE_UPGRADE_FLAT_BLUE,
	NEWBIE_WAVE_FEW_FAST,
	MIDDLE_UPGRADE_FLAT_GRAY,
	MIDDLE_WAVE_FAST,
	WAVE_STRONGER,
	END_UPGRADE_WYELLOW,
	END_MIDDLE_UPGRADE,
	END_WAVE_BIG,
	END_UPGRADE_LIGHT_BLUE,
	END_UPGRADE_LIGHT_BLUE_1,
	END_UPGRADE_WHITE_BLUE,
	ZEN_WAVE_FASTEST,
	UPGRADE_RED_STANDARD,
	UPGRADE_RED_BLUE,
	UPGRADE_RED_WHITE_BLUE,
	UPGRADE_RED_BIG_BLUE,
	UPGRADE_RED_GRAY,
	UPGRADE_RED_SMALL_WHITE_BLUE,
	UPGRADE_RED_SMALL_WHITE_BLUE_1,
	UPGRADE_RED_SMALL_WHITE_BLUE_2,
	UPGRADE_RED_YELLOW,
	UPGRADE_RED_RED,
	UPGRADE_RED,
	UPGRADE_RED_LIGHT,
	WAVE_ST_5,
	WAVE_ST_6,
	WAVE_ST_10,
	WAVE_ST_11,
	WAVE_BIG_2,
	WAVE_BIG_7,
}

var gift_border := {
	"type": EventType.GIFT,
	"chance": 1,
	"variant": Gift.GiftVariant.BORDER,
}
var gift_drop := {
	"type": EventType.GIFT,
	"chance": 1,
	"variant": Gift.GiftVariant.DROP,
}
var gift_fling := {
	"type": EventType.GIFT,
	"chance": 1,
	"variant": Gift.GiftVariant.FLING,
}
var gift_random := {
	"type": EventType.GIFT,
	"chance": 1,
	"variant": Gift.GiftVariant.RANDOM,
}
var gift_renewal := {
	"type": EventType.GIFT,
	"chance": 1,
	"variant": Gift.GiftVariant.RENEWAL,
}
var gift_boost := {
	"type": EventType.GIFT,
	"chance": 1,
	"variant": Gift.GiftVariant.BOOST,
}
var gift_border_05 := {
	"type": EventType.GIFT,
	"chance": 0.5,
	"variant": Gift.GiftVariant.BORDER,
}
var gift_drop_05 := {
	"type": EventType.GIFT,
	"chance": 0.5,
	"variant": Gift.GiftVariant.DROP,
}
var gift_fling_05 := {
	"type": EventType.GIFT,
	"chance": 0.5,
	"variant": Gift.GiftVariant.FLING,
}
var gift_random_05 := {
	"type": EventType.GIFT,
	"chance": 0.5,
	"variant": Gift.GiftVariant.RANDOM,
}
var gift_renewal_05 := {
	"type": EventType.GIFT,
	"chance": 0.5,
	"variant": Gift.GiftVariant.RENEWAL,
}
var gift_boost_05 := {
	"type": EventType.GIFT,
	"chance": 0.5,
	"variant": Gift.GiftVariant.BOOST,
}
var alarm_5 := {
	"type": EventType.WARNING,
	"timeout": 5.0,
}
var alarm_10 := {
	"type": EventType.WARNING,
	"timeout": 10.0,
}
var alarm_15 := {
	"type": EventType.WARNING,
	"timeout": 15.0,
}
var alarm_20 := {
	"type": EventType.WARNING,
	"timeout": 20.0,
}
var test_wave := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 0.1,
	"timeout_max": 0.2,
	"meteors": [
		{ "count": 1, "variant": Meteor.Variants.Variant.BIG_0 },
		{ "count": 2, "variant": Meteor.Variants.Variant.BIG_1 },
		{ "count": 1, "variant": Meteor.Variants.Variant.BIG_2 },
	],
}
var test_upgrade := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.FLAT,
	"gun_repair": true,
	"timeout": 10.0,  # 0.0 - no rollback
}
var newbie_wave := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 0.3,
	"timeout_max": 1.2,
	"meteors": [
		{ "count": 15, "variant": Meteor.Variants.Variant.ST_5 },
		{ "count": 15, "variant": Meteor.Variants.Variant.ST_6 },
	],
}
var newbie_wave_many := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 0.1,
	"timeout_max": 0.3,
	"meteors": [
		{ "count": 45, "variant": Meteor.Variants.Variant.ST_1 },
		{ "count": 45, "variant": Meteor.Variants.Variant.ST_2 },
	],
}
var newbie_upgrade_15 := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.STANDARD_FAST,
	"gun_repair": false,
	"timeout": 15.0,
}
var newbie_upgrade_gun := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.FLAT,
	"gun_repair": true,
	"timeout": 0.0,
}
var newbie_upgrade_flat_blue := {
	"type": EventType.GUN_UPGRADE,
	"name": "newbie_upgrade_flat_blue",
	"gun_variant": Gun.Variants.Variant.FLAT_BLUE,
	"gun_repair": false,
	"timeout": 0.0,
}
var newbie_wave_few_fast := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 1.5,
	"timeout_max": 3.0,
	"meteors": [
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_6 },
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_5 },
	],
}
var middle_upgrade_flat_gray := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.FLAT_GRAY,
	"gun_repair": false,
	"timeout": 0.0,
}
var middle_wave_fast := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 2.5,
	"timeout_max": 4.0,
	"meteors": [
		{ "count": 11, "variant": Meteor.Variants.Variant.ST_10 },
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_9 },
	],
}
var wave_stronger := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 0.1,
	"timeout_max": 0.4,
	"meteors": [
		{ "count": 130, "variant": Meteor.Variants.Variant.ST_13 },
	],
}
var end_upgrade_wyellow := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.BLUE_WYELLOW,
	"gun_repair": true,
	"timeout": 30.0,
}
var end_middle_upgrade := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.BLUE_WYELLOW_FAST,
	"gun_repair": true,
	"timeout": 0.0,
}
var end_wave_big := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 2.5,
	"timeout_max": 4.0,
	"meteors": [
		{ "count": 1, "variant": Meteor.Variants.Variant.BIG_5 },
	],
}
var end_upgrade_light_blue := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.BLUE_LIGHT_BLUE,
	"gun_repair": true,
	"timeout": 15.0,
}
var end_upgrade_light_blue_1 := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.BLUE_LIGHT_BLUE_1,
	"gun_repair": false,
	"timeout": 15.0,
}
var end_upgrade_white_blue := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.BLUE_WBLUE,
	"gun_repair": false,
	"timeout": 30.0,
}
var zen_wave_fastest := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 0.5,
	"timeout_max": 1.0,
	"meteors": [
		{ "count": 20, "variant": Meteor.Variants.Variant.ST_11 },
		{ "count": 10, "variant": Meteor.Variants.Variant.BIG_2 },
	],
}
var upgrade_red_standard := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED_STANDARD,
	"gun_repair": false,
	"timeout": 0,
}
var upgrade_red_blue := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED_BLUE,
	"gun_repair": false,
	"timeout": 0,
}
var upgrade_red_white_blue := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED_WHITE_BLUE,
	"gun_repair": false,
	"timeout": 0,
}
var upgrade_red_big_blue := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED_BIG_BLUE,
	"gun_repair": false,
	"timeout": 0,
}
var upgrade_red_gray := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED_GRAY,
	"gun_repair": false,
	"timeout": 0,
}
var upgrade_red_small_white_blue := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED_SMALL_WHITE_BLUE,
	"gun_repair": false,
	"timeout": 0,
}
var upgrade_red_small_white_blue_1 := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED_SMALL_WHITE_BLUE_1,
	"gun_repair": false,
	"timeout": 0,
}
var upgrade_red_small_white_blue_2 := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED_SMALL_WHITE_BLUE_2,
	"gun_repair": false,
	"timeout": 0,
}
var upgrade_red_yellow := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED_YELLOW,
	"gun_repair": false,
	"timeout": 0,
}
var upgrade_red_red := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED_RED,
	"gun_repair": false,
	"timeout": 0,
}
var upgrade_red := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED,
	"gun_repair": false,
	"timeout": 0,
}
var upgrade_red_light := {
	"type": EventType.GUN_UPGRADE,
	"gun_variant": Gun.Variants.Variant.RED_LIGHT,
	"gun_repair": false,
	"timeout": 0,
}
var wave_st_5 := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 0.5,
	"timeout_max": 0.7,
	"meteors": [
		{ "count": 50, "variant": Meteor.Variants.Variant.ST_5 },
	],
}
var wave_st_6 := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 0.5,
	"timeout_max": 0.7,
	"meteors": [
		{ "count": 50, "variant": Meteor.Variants.Variant.ST_6 },
	],
}
var wave_st_10 := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 0.7,
	"timeout_max": 1.5,
	"meteors": [
		{ "count": 40, "variant": Meteor.Variants.Variant.ST_10 },
	],
}
var wave_st_11 := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 0.8,
	"timeout_max": 1.7,
	"meteors": [
		{ "count": 40, "variant": Meteor.Variants.Variant.ST_11 },
	],
}
var wave_big_2 := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 0.5,
	"timeout_max": 1.0,
	"meteors": [
		{ "count": 50, "variant": Meteor.Variants.Variant.BIG_2 },
	],
}
var wave_big_7 := {
	"type": EventType.METEORS_WAVE,
	"timeout_min": 0.5,
	"timeout_max": 1.2,
	"meteors": [
		{ "count": 35, "variant": Meteor.Variants.Variant.BIG_7 },
	],
}


func get_vars(variant) -> Dictionary:
	match(variant):
		EventVariant.GIFT_BOOST:
			return gift_boost
		EventVariant.GIFT_BORDER:
			return gift_border
		EventVariant.GIFT_DROP:
			return gift_drop
		EventVariant.GIFT_FLING:
			return gift_fling
		EventVariant.GIFT_RANDOM:
			return gift_random
		EventVariant.GIFT_RENEWAL:
			return gift_renewal
		EventVariant.GIFT_BOOST_05:
			return gift_boost_05
		EventVariant.GIFT_BORDER_05:
			return gift_border_05
		EventVariant.GIFT_DROP_05:
			return gift_drop_05
		EventVariant.GIFT_FLING_05:
			return gift_fling_05
		EventVariant.GIFT_RANDOM_05:
			return gift_random_05
		EventVariant.GIFT_RENEWAL_05:
			return gift_renewal_05
		EventVariant.ALARM_5:
			return alarm_5
		EventVariant.ALARM_10:
			return alarm_10
		EventVariant.ALARM_15:
			return alarm_15
		EventVariant.ALARM_20:
			return alarm_20
		EventVariant.TEST_WAVE:
			return test_wave
		EventVariant.TEST_UPGRADE:
			return test_upgrade
		EventVariant.NEWBIE_WAVE:
			return newbie_wave
		EventVariant.NEWBIE_WAVE_MANY:
			return newbie_wave_many
		EventVariant.NEWBIE_UPGRADE_15:
			return newbie_upgrade_15
		EventVariant.NEWBIE_UPGRADE_GUN:
			return newbie_upgrade_gun
		EventVariant.NEWBIE_UPGRADE_FLAT_BLUE:
			return newbie_upgrade_flat_blue
		EventVariant.NEWBIE_WAVE_FEW_FAST:
			return newbie_wave_few_fast
		EventVariant.MIDDLE_UPGRADE_FLAT_GRAY:
			return middle_upgrade_flat_gray
		EventVariant.MIDDLE_WAVE_FAST:
			return middle_wave_fast
		EventVariant.WAVE_STRONGER:
			return wave_stronger
		EventVariant.END_UPGRADE_WYELLOW:
			return end_upgrade_wyellow
		EventVariant.END_MIDDLE_UPGRADE:
			return end_middle_upgrade
		EventVariant.END_WAVE_BIG:
			return end_wave_big
		EventVariant.END_UPGRADE_LIGHT_BLUE:
			return end_upgrade_light_blue
		EventVariant.END_UPGRADE_LIGHT_BLUE_1:
			return end_upgrade_light_blue_1
		EventVariant.END_UPGRADE_WHITE_BLUE:
			return end_upgrade_white_blue
		EventVariant.ZEN_WAVE_FASTEST:
			return zen_wave_fastest
		EventVariant.UPGRADE_RED_STANDARD:
			return upgrade_red_standard
		EventVariant.UPGRADE_RED_BLUE:
			return upgrade_red_blue
		EventVariant.UPGRADE_RED_WHITE_BLUE:
			return upgrade_red_white_blue
		EventVariant.UPGRADE_RED_BIG_BLUE:
			return upgrade_red_big_blue
		EventVariant.UPGRADE_RED_GRAY:
			return upgrade_red_gray
		EventVariant.UPGRADE_RED_SMALL_WHITE_BLUE:
			return upgrade_red_small_white_blue
		EventVariant.UPGRADE_RED_SMALL_WHITE_BLUE_1:
			return upgrade_red_small_white_blue_1
		EventVariant.UPGRADE_RED_SMALL_WHITE_BLUE_2:
			return upgrade_red_small_white_blue_2
		EventVariant.UPGRADE_RED_YELLOW:
			return upgrade_red_yellow
		EventVariant.UPGRADE_RED_RED:
			return upgrade_red_red
		EventVariant.UPGRADE_RED:
			return upgrade_red
		EventVariant.UPGRADE_RED_LIGHT:
			return upgrade_red_light
		EventVariant.WAVE_ST_5:
			return wave_st_5
		EventVariant.WAVE_ST_6:
			return wave_st_6
		EventVariant.WAVE_ST_10:
			return wave_st_10
		EventVariant.WAVE_ST_11:
			return wave_st_11
		EventVariant.WAVE_BIG_2:
			return wave_big_2
		EventVariant.WAVE_BIG_7:
			return wave_big_7
		_:
			return gift_border
