class_name Levels
extends Object


enum Level {
	TEST,
	NEWBIE,
	NEWBIE_1,
	NEWBIE_2,
	MIDDLE,
	MIDDLE_RELAX,
	MIDDLE_EASY,
	END,
	END_MIDDLE,
	END_END,
	ZEN_START,
	ZEN_MIDDLE,
	ZEN_NEXT,
	ZEN_ENDLESS,
}
enum RndMeteorsMode {
	RANDOM,  # replace to random amount (min-max range)
	ALL,  # replace (mix) all (random amount not change)
	SOME,  # replame one (not uniq)
	NONE,
}
enum RndEventsMode {
	RANDOM,
	ORDER,
	NONE,
}

var test := {
	"meteors": [
		{ "count": 7, "variant": Meteor.Variants.Variant.STANDARD },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_5 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_7 },
	],
	"gun_variant": Gun.Variants.Variant.STANDARD,
	"gun_repair": false,
	"track": 0,
	"time": 120.0,  # 0 - infinite
	"time_wait": 10.0,  # 0 - no wait
	"hearts": true,
	"wait_clear": true,
	"end_game": false,  # need wait_clear = true
	"cheat_play": false,  # need set time_wait
	"endless_splash": false,
	"show_donate": false,  # don't true simultaneously
	"show_review": false,
	"fortune_coef": 0.2,
	"next_level": Level.TEST,
	"action_random": {
		"enabled": true,
		"amount": 10,
		"speed": 5,
		"interval": 0.25,
	},
	"action_boost": {
		"enabled": true,
		"boost": 5,
		"timeout": 15.0,
		"speed": 2,
	},
	"action_border": {
		"enabled": true,
		"timeout": 20.0,
		"speed": 6,
	},
	"action_drop": {
		"enabled": true,
		"amount": 250,
		"variants": {
			"yellow": { "amount": 5, "impulse": 1000.0 },
			"red": { "amount": 5, "impulse": 900.0 },
			"blue": { "amount": 5, "impulse": 800.0 },
		},
		"interval_min": 0.04,
		"interval_max": 0.07,
		"animation": Drop.DropVariant.BLUE,
		"speed": 5,
	},
	"events": {
		1: Events.EventVariant.GIFT_BORDER,
		5: Events.EventVariant.TEST_UPGRADE,
		10: Events.EventVariant.TEST_WAVE,
		125: Events.EventVariant.ALARM_5,
	},
	"random": {
		"enabled": false,
		"meteors": {
			"variants": { "min": 2, "max": 3 },  # max must be <= meteors.size()
			"change_interval": { "min": 10.0, "max": 30.0 },
			"mode": RndMeteorsMode.SOME,
		},
		"events": {
			"interval": { "min": 10.0, "max": 30.0, },
			"list": [ 1, 5, 10 ],
			"mode": RndEventsMode.ORDER,
		},
	},
}
var newbie := {
	"meteors": [
		{ "count": 7, "variant": Meteor.Variants.Variant.STANDARD },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_4 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_7 },
	],
	"gun_variant": Gun.Variants.Variant.STANDARD_NEWBIE,
	"gun_repair": false,
	"track": 0,
	"time": 120.0,
	"time_wait": 0.0,
	"hearts": false,
	"wait_clear": false,
	"end_game": false,
	"cheat_play": false,
	"endless_splash": false,
	"show_donate": false,
	"show_review": true,
	"fortune_coef": 0.1,
	"next_level": Level.NEWBIE_1,
	"action_random": {
		"enabled": false,
		"amount": 10,
		"speed": 5,
		"interval": 0.25,
	},
	"action_boost": {
		"enabled": false,
		"boost": 2,
		"timeout": 25.0,
		"speed": 2,
	},
	"action_border": {
		"enabled": false,
		"timeout": 25.0,
		"speed": 6,
	},
	"action_drop": {
		"enabled": false,
		"amount": 250,
		"variants": {
			"yellow": { "amount": 5, "impulse": 1000.0 },
			"red": { "amount": 0, "impulse": 900.0 },
			"blue": { "amount": 0, "impulse": 800.0 },
		},
		"interval_min": 0.04,
		"interval_max": 0.07,
		"animation": Drop.DropVariant.YELLOW,
		"speed": 5,
	},
	"events": {
		29.9: Events.EventVariant.ALARM_20,
		30: Events.EventVariant.GIFT_BORDER,
		34: Events.EventVariant.NEWBIE_WAVE,
		42: Events.EventVariant.GIFT_BOOST_05,
		59: Events.EventVariant.ALARM_5,
		60: Events.EventVariant.NEWBIE_WAVE_MANY,
		64: Events.EventVariant.NEWBIE_UPGRADE_15,
		69: Events.EventVariant.GIFT_BOOST_05,
		73: Events.EventVariant.GIFT_BORDER_05,
		82: Events.EventVariant.NEWBIE_UPGRADE_GUN,
	},
	"random": { "enabled": false },
}
var newbie_1 := {
	"meteors": [
		{ "count": 7, "variant": Meteor.Variants.Variant.STANDARD },
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_4 },
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_7 },
		{ "count": 7, "variant": Meteor.Variants.Variant.ST_1 },
		{ "count": 7, "variant": Meteor.Variants.Variant.ST_2 },
	],
	"gun_variant": Gun.Variants.Variant.FLAT,
	"gun_repair": false,
	"track": 0,
	"time": 140.0,
	"time_wait": 0.0,
	"hearts": false,
	"wait_clear": false,
	"end_game": false,
	"cheat_play": false,
	"endless_splash": false,
	"show_donate": false,
	"show_review": true,
	"fortune_coef": 0.1,
	"next_level": Level.NEWBIE_2,
	"action_random": {
		"enabled": false,
		"amount": 25,
		"speed": 5,
		"interval": 0.25,
	},
	"action_boost": {
		"enabled": false,
		"boost": 2,
		"timeout": 25.0,
		"speed": 2,
	},
	"action_border": {
		"enabled": true,
		"timeout": 15.0,
		"speed": 5,
	},
	"action_drop": {
		"enabled": false,
		"amount": 100,
		"variants": {
			"yellow": { "amount": 5, "impulse": 1000.0 },
			"red": { "amount": 0, "impulse": 900.0 },
			"blue": { "amount": 0, "impulse": 800.0 },
		},
		"interval_min": 0.07,
		"interval_max": 0.1,
		"animation": Drop.DropVariant.YELLOW,
		"speed": 5,
	},
	"events": {
		20: Events.EventVariant.GIFT_RANDOM,
		35: Events.EventVariant.ALARM_20,
		35.1: Events.EventVariant.GIFT_BORDER_05,
		40: Events.EventVariant.NEWBIE_WAVE,
		43: Events.EventVariant.GIFT_DROP,
		45: Events.EventVariant.NEWBIE_WAVE_MANY,
		70: Events.EventVariant.NEWBIE_UPGRADE_FLAT_BLUE,
		80: Events.EventVariant.GIFT_RANDOM_05,
	},
	"random": { "enabled": false },
}
var newbie_2 := {
	"meteors": [
		{ "count": 7, "variant": Meteor.Variants.Variant.STANDARD },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_3 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_7 },
	],
	"gun_variant": Gun.Variants.Variant.STANDARD_WHITE_BLUE,
	"gun_repair": true,
	"track": 0,
	"time": 60.0,
	"time_wait": 10.0,
	"hearts": false,
	"wait_clear": false,
	"end_game": false,
	"cheat_play": false,
	"endless_splash": false,
	"show_donate": false,
	"show_review": true,
	"fortune_coef": 0.1,
	"next_level": Level.MIDDLE,
	"action_random": {
		"enabled": false,
		"amount": 10,
		"speed": 5,
		"interval": 0.25,
	},
	"action_boost": {
		"enabled": true,
		"boost": 2,
		"timeout": 25.0,
		"speed": 2,
	},
	"action_border": {
		"enabled": false,
		"timeout": 25.0,
		"speed": 6,
	},
	"action_drop": {
		"enabled": false,
		"amount": 100,
		"variants": {
			"yellow": { "amount": 5, "impulse": 1000.0 },
			"red": { "amount": 0, "impulse": 900.0 },
			"blue": { "amount": 0, "impulse": 800.0 },
		},
		"interval_min": 0.07,
		"interval_max": 0.1,
		"animation": Drop.DropVariant.YELLOW,
		"speed": 5,
	},
	"events": {
		5: Events.EventVariant.GIFT_BOOST_05,
		19.9: Events.EventVariant.ALARM_10,
		20: Events.EventVariant.NEWBIE_WAVE_FEW_FAST,
		23: Events.EventVariant.GIFT_DROP_05,
	},
	"random": { "enabled": false },
}
var middle := {
	"meteors": [
		{ "count": 4, "variant": Meteor.Variants.Variant.ST_3 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_4 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_7 },
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_8 },
	],
	"gun_variant": Gun.Variants.Variant.STANDARD_WHITE_BLUE,
	"gun_repair": false,
	"track": 1,
	"time": 120.0,
	"time_wait": 0.0,
	"hearts": false,
	"wait_clear": false,
	"end_game": false,
	"cheat_play": false,
	"endless_splash": false,
	"show_donate": false,
	"show_review": true,
	"fortune_coef": 0.1,
	"next_level": Level.MIDDLE_RELAX,
	"action_random": {
		"enabled": true,
		"amount": 20,
		"speed": 5,
		"interval": 0.2,
	},
	"action_boost": {
		"enabled": false,
		"boost": 2,
		"timeout": 20.0,
		"speed": 2,
	},
	"action_border": {
		"enabled": true,
		"timeout": 15.0,
		"speed": 4,
	},
	"action_drop": {
		"enabled": false,
		"amount": 100,
		"variants": {
			"yellow": { "amount": 5, "impulse": 1000.0 },
			"red": { "amount": 0, "impulse": 900.0 },
			"blue": { "amount": 0, "impulse": 800.0 },
		},
		"interval_min": 0.07,
		"interval_max": 0.1,
		"animation": Drop.DropVariant.YELLOW,
		"speed": 5,
	},
	"events": {
		30: Events.EventVariant.GIFT_DROP_05,
		60: Events.EventVariant.MIDDLE_UPGRADE_FLAT_GRAY,
		70: Events.EventVariant.GIFT_BOOST_05,
		80: Events.EventVariant.ALARM_5,
		81: Events.EventVariant.MIDDLE_WAVE_FAST,
	},
	"random": { "enabled": false },
}
var middle_relax := {
	"meteors": [
		{ "count": 2, "variant": Meteor.Variants.Variant.STANDARD },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_1 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_2 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_3 },
		{ "count": 8, "variant": Meteor.Variants.Variant.ST_4 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_5 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_6 },
		{ "count": 6, "variant": Meteor.Variants.Variant.ST_7 },
		{ "count": 3, "variant": Meteor.Variants.Variant.ST_8 },
	],
	"gun_variant": Gun.Variants.Variant.FLAT_GRAY,
	"gun_repair": false,
	"track": 1,
	"time": 180.0,
	"time_wait": 0.0,
	"hearts": false,
	"wait_clear": false,
	"end_game": false,
	"cheat_play": false,
	"endless_splash": false,
	"show_donate": false,
	"show_review": true,
	"fortune_coef": 0.2,
	"next_level": Level.MIDDLE_EASY,
	"action_random": {
		"enabled": true,
		"amount": 25,
		"speed": 7,
		"interval": 0.1,
	},
	"action_boost": {
		"enabled": true,
		"boost": 3,
		"timeout": 20.0,
		"speed": 2,
	},
	"action_border": {
		"enabled": true,
		"timeout": 15.0,
		"speed": 3,
	},
	"action_drop": {
		"enabled": true,
		"amount": 130,
		"variants": {
			"yellow": { "amount": 7, "impulse": 1000.0 },
			"red": { "amount": 0, "impulse": 900.0 },
			"blue": { "amount": 0, "impulse": 800.0 },
		},
		"interval_min": 0.07,
		"interval_max": 0.1,
		"animation": Drop.DropVariant.YELLOW,
		"speed": 2,
	},
	"events": {
		55: Events.EventVariant.GIFT_BOOST,
		60: Events.EventVariant.ALARM_5,
		61: Events.EventVariant.MIDDLE_WAVE_FAST,
		62: Events.EventVariant.GIFT_RENEWAL,
		70: Events.EventVariant.GIFT_DROP_05,
		110: Events.EventVariant.ALARM_15,
		114: Events.EventVariant.GIFT_BORDER_05,
		115: Events.EventVariant.NEWBIE_WAVE_FEW_FAST,
		120: Events.EventVariant.GIFT_RANDOM_05,
		125: Events.EventVariant.GIFT_RENEWAL,
	},
	"random": { "enabled": false },
}
var middle_easy := {
	"meteors": [
		{ "count": 1, "variant": Meteor.Variants.Variant.STANDARD },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_1 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_2 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_3 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_4 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_5 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_6 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_7 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_8 },
	],
	"gun_variant": Gun.Variants.Variant.FLAT_SW_BLUE,
	"gun_repair": true,
	"track": 1,
	"time": 140.0,
	"time_wait": 10.0,
	"hearts": false,
	"wait_clear": true,
	"end_game": false,
	"cheat_play": false,
	"endless_splash": false,
	"show_donate": false,
	"show_review": true,
	"fortune_coef": 0.15,
	"next_level": Level.END,
	"action_random": {
		"enabled": true,
		"amount": 20,
		"speed": 5,
		"interval": 0.15,
	},
	"action_boost": {
		"enabled": true,
		"boost": 2,
		"timeout": 25.0,
		"speed": 1,
	},
	"action_border": {
		"enabled": true,
		"timeout": 20.0,
		"speed": 2,
	},
	"action_drop": {
		"enabled": true,
		"amount": 120,
		"variants": {
			"yellow": { "amount": 7, "impulse": 1000.0 },
			"red": { "amount": 0, "impulse": 900.0 },
			"blue": { "amount": 0, "impulse": 800.0 },
		},
		"interval_min": 0.07,
		"interval_max": 0.1,
		"animation": Drop.DropVariant.YELLOW,
		"speed": 1,
	},
	"events": {
		50: Events.EventVariant.GIFT_RENEWAL_05,
		90: Events.EventVariant.GIFT_RENEWAL_05,
	},
	"random": { "enabled": false },
}
var end := {
	"meteors": [
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_10 },
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_12 },
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_14 },
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_15 },
	],
	"gun_variant": Gun.Variants.Variant.BLUE,
	"gun_repair": true,
	"track": 2,
	"time": 240.0,
	"time_wait": 0.0,
	"hearts": false,
	"wait_clear": false,
	"end_game": false,
	"cheat_play": false,
	"endless_splash": false,
	"show_donate": false,
	"show_review": true,
	"fortune_coef": 0.1,
	"next_level": Level.END_MIDDLE,
	"action_random": {
		"enabled": true,
		"amount": 50,
		"speed": 5,
		"interval": 0.15,
	},
	"action_boost": {
		"enabled": true,
		"boost": 3,
		"timeout": 15.0,
		"speed": 2,
	},
	"action_border": {
		"enabled": true,
		"timeout": 15.0,
		"speed": 4,
	},
	"action_drop": {
		"enabled": true,
		"amount": 150,
		"variants": {
			"yellow": { "amount": 7, "impulse": 1000.0 },
			"red": { "amount": 4, "impulse": 900.0 },
			"blue": { "amount": 0, "impulse": 800.0 },
		},
		"interval_min": 0.07,
		"interval_max": 0.1,
		"animation": Drop.DropVariant.RED,
		"speed": 3,
	},
	"events": {
		1: Events.EventVariant.GIFT_RENEWAL,
		87: Events.EventVariant.ALARM_15,
		89: Events.EventVariant.GIFT_BORDER,
		90: Events.EventVariant.WAVE_STRONGER,
		91: Events.EventVariant.GIFT_BOOST_05,
		95: Events.EventVariant.GIFT_RENEWAL,
		96: Events.EventVariant.END_UPGRADE_WHITE_BLUE,
		105: Events.EventVariant.GIFT_DROP_05,
		145: Events.EventVariant.GIFT_RENEWAL,
		180: Events.EventVariant.END_UPGRADE_WYELLOW,
		185: Events.EventVariant.ALARM_10,
		187: Events.EventVariant.MIDDLE_WAVE_FAST,
		188: Events.EventVariant.GIFT_BORDER,
		194: Events.EventVariant.GIFT_RANDOM,
		210: Events.EventVariant.GIFT_RENEWAL_05,
	},
	"random": { "enabled": false },
}
var end_middle := {
	"meteors": [
		{ "count": 3, "variant": Meteor.Variants.Variant.STANDARD },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_5 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_7 },
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_12 },
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_14 },
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_15 },
	],
	"gun_variant": Gun.Variants.Variant.BLUE_WYELLOW,
	"gun_repair": false,
	"track": 2,
	"time": 240.0,
	"time_wait": 10.0,
	"hearts": false,
	"wait_clear": false,
	"end_game": false,
	"cheat_play": false,
	"endless_splash": false,
	"show_donate": false,
	"show_review": true,
	"fortune_coef": 0.1,
	"next_level": Level.END_END,
	"action_random": {
		"enabled": false,
		"amount": 60,
		"speed": 5,
		"interval": 0.25,
	},
	"action_boost": {
		"enabled": false,
		"boost": 3,
		"timeout": 15.0,
		"speed": 2,
	},
	"action_border": {
		"enabled": false,
		"timeout": 15.0,
		"speed": 4,
	},
	"action_drop": {
		"enabled": false,
		"amount": 220,
		"variants": {
			"yellow": { "amount": 7, "impulse": 1600.0 },
			"red": { "amount": 5, "impulse": 1000.0 },
			"blue": { "amount": 0, "impulse": 800.0 },
		},
		"interval_min": 0.02,
		"interval_max": 0.05,
		"animation": Drop.DropVariant.RED,
		"speed": 3,
	},
	"events": {
		10: Events.EventVariant.GIFT_BOOST,
		35: Events.EventVariant.GIFT_DROP,
		50: Events.EventVariant.GIFT_BORDER,
		60: Events.EventVariant.GIFT_RANDOM,
		75: Events.EventVariant.GIFT_BOOST,
		100: Events.EventVariant.GIFT_BORDER,
		101: Events.EventVariant.END_UPGRADE_LIGHT_BLUE,
		120: Events.EventVariant.END_UPGRADE_LIGHT_BLUE_1,
		125: Events.EventVariant.GIFT_DROP,
		140: Events.EventVariant.GIFT_RANDOM,
		150: Events.EventVariant.GIFT_BORDER,
		165: Events.EventVariant.GIFT_BOOST,
		180: Events.EventVariant.END_MIDDLE_UPGRADE,
	},
	"random": { "enabled": false },
}
var end_end := {
	"meteors": [
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_1 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_2 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_3 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_4 },
		{ "count": 1, "variant": Meteor.Variants.Variant.ST_6 },
		{ "count": 3, "variant": Meteor.Variants.Variant.ST_8 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_12 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_14 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_15 },
	],
	"gun_variant": Gun.Variants.Variant.BLUE_BLUE,
	"gun_repair": true,
	"track": 2,
	"time": 80.0,
	"time_wait": 15.0,
	"hearts": false,
	"wait_clear": true,
	"end_game": true,
	"cheat_play": false,
	"endless_splash": false,
	"show_donate": false,
	"show_review": true,
	"fortune_coef": 0.2,
	"next_level": Level.NEWBIE,
	"action_random": {
		"enabled": false,
		"amount": 60,
		"speed": 5,
		"interval": 0.25,
	},
	"action_boost": {
		"enabled": false,
		"boost": 3,
		"timeout": 15.0,
		"speed": 2,
	},
	"action_border": {
		"enabled": false,
		"timeout": 15.0,
		"speed": 4,
	},
	"action_drop": {
		"enabled": false,
		"amount": 220,
		"variants": {
			"yellow": { "amount": 7, "impulse": 1600.0 },
			"red": { "amount": 5, "impulse": 1000.0 },
			"blue": { "amount": 0, "impulse": 800.0 },
		},
		"interval_min": 0.02,
		"interval_max": 0.05,
		"animation": Drop.DropVariant.RED,
		"speed": 3,
	},
	"events": {
		37: Events.EventVariant.ALARM_5,
		40: Events.EventVariant.END_WAVE_BIG,
	},
	"random": { "enabled": false },
}
var zen_start := {
	"meteors": [
		{ "count": 2, "variant": Meteor.Variants.Variant.STANDARD },
		{ "count": 3, "variant": Meteor.Variants.Variant.ST_4 },
		{ "count": 4, "variant": Meteor.Variants.Variant.ST_16 },
		{ "count": 1, "variant": Meteor.Variants.Variant.BIG_0 },
	],
	"gun_variant": Gun.Variants.Variant.RED,
	"gun_repair": false,
	"track": 3,
	"time": 120.0,
	"time_wait": 0.0,
	"hearts": true,
	"wait_clear": true,
	"end_game": false,
	"cheat_play": false,
	"endless_splash": false,
	"show_donate": true,
	"show_review": false,
	"fortune_coef": 0.2,
	"next_level": Level.ZEN_MIDDLE,
	"action_random": {
		"enabled": true,
		"amount": 10,
		"speed": 5,
		"interval": 0.25,
	},
	"action_boost": {
		"enabled": true,
		"boost": 4,
		"timeout": 15.0,
		"speed": 2,
	},
	"action_border": {
		"enabled": true,
		"timeout": 20.0,
		"speed": 6,
	},
	"action_drop": {
		"enabled": true,
		"amount": 250,
		"variants": {
			"yellow": { "amount": 5, "impulse": 1000.0 },
			"red": { "amount": 5, "impulse": 900.0 },
			"blue": { "amount": 5, "impulse": 800.0 },
		},
		"interval_min": 0.04,
		"interval_max": 0.07,
		"animation": Drop.DropVariant.BLUE,
		"speed": 5,
	},
	"events": {
		1: Events.EventVariant.GIFT_BORDER,
		7: Events.EventVariant.ALARM_10,
		10: Events.EventVariant.ZEN_WAVE_FASTEST,
		15: Events.EventVariant.GIFT_RENEWAL,
		30: Events.EventVariant.GIFT_FLING,
		60: Events.EventVariant.GIFT_FLING_05,
		125: Events.EventVariant.ALARM_5,
	},
	"random": { "enabled": false },
}
var zen_middle := {
	"meteors": [
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_7 },
		{ "count": 4, "variant": Meteor.Variants.Variant.BIG_0 },
		{ "count": 3, "variant": Meteor.Variants.Variant.BIG_1 },
		{ "count": 4, "variant": Meteor.Variants.Variant.BIG_3 },
	],
	"gun_variant": Gun.Variants.Variant.RED_RED,
	"gun_repair": true,
	"track": 3,
	"time": 180.0,
	"time_wait": 0.0,
	"hearts": true,
	"wait_clear": true,
	"end_game": false,
	"cheat_play": false,
	"endless_splash": false,
	"show_donate": true,
	"show_review": false,
	"fortune_coef": 0.2,
	"next_level": Level.ZEN_NEXT,
	"action_random": {
		"enabled": true,
		"amount": 15,
		"speed": 5,
		"interval": 0.25,
	},
	"action_boost": {
		"enabled": true,
		"boost": 4,
		"timeout": 15.0,
		"speed": 2,
	},
	"action_border": {
		"enabled": true,
		"timeout": 10.0,
		"speed": 6,
	},
	"action_drop": {
		"enabled": true,
		"amount": 180,
		"variants": {
			"yellow": { "amount": 5, "impulse": 1000.0 },
			"red": { "amount": 5, "impulse": 900.0 },
			"blue": { "amount": 5, "impulse": 800.0 },
		},
		"interval_min": 0.04,
		"interval_max": 0.07,
		"animation": Drop.DropVariant.BLUE,
		"speed": 5,
	},
	"events": {
		1: Events.EventVariant.GIFT_RENEWAL,
		15: Events.EventVariant.GIFT_FLING_05,
		30: Events.EventVariant.GIFT_FLING_05,
		45: Events.EventVariant.GIFT_FLING_05,
		60: Events.EventVariant.GIFT_FLING_05,
		75: Events.EventVariant.GIFT_FLING_05,
		90: Events.EventVariant.GIFT_FLING_05,
		105: Events.EventVariant.GIFT_FLING_05,
		120: Events.EventVariant.GIFT_FLING_05,
		135: Events.EventVariant.GIFT_FLING_05,
		150: Events.EventVariant.GIFT_FLING_05,
		165: Events.EventVariant.GIFT_FLING_05,
	},
	"random": { "enabled": false },
}
var zen_next := {
	"meteors": [
		{ "count": 5, "variant": Meteor.Variants.Variant.ST_3 },
		{ "count": 4, "variant": Meteor.Variants.Variant.BIG_4 },
		{ "count": 3, "variant": Meteor.Variants.Variant.BIG_6 },
		{ "count": 1, "variant": Meteor.Variants.Variant.BIG_7 },
	],
	"gun_variant": Gun.Variants.Variant.RED_LIGHT,
	"gun_repair": true,
	"track": 3,
	"time": 120.0,
	"time_wait": 15.0,
	"hearts": true,
	"wait_clear": true,
	"end_game": false,
	"cheat_play": true,
	"endless_splash": false,
	"show_donate": true,
	"show_review": false,
	"fortune_coef": 0.2,
	"next_level": Level.ZEN_START,
	"action_random": {
		"enabled": true,
		"amount": 15,
		"speed": 5,
		"interval": 0.25,
	},
	"action_boost": {
		"enabled": true,
		"boost": 5,
		"timeout": 15.0,
		"speed": 5,
	},
	"action_border": {
		"enabled": true,
		"timeout": 15.0,
		"speed": 6,
	},
	"action_drop": {
		"enabled": true,
		"amount": 180,
		"variants": {
			"yellow": { "amount": 5, "impulse": 1000.0 },
			"red": { "amount": 5, "impulse": 900.0 },
			"blue": { "amount": 5, "impulse": 800.0 },
		},
		"interval_min": 0.04,
		"interval_max": 0.07,
		"animation": Drop.DropVariant.BLUE,
		"speed": 5,
	},
	"events": {
		1: Events.EventVariant.GIFT_RENEWAL,
		15: Events.EventVariant.GIFT_FLING_05,
		30: Events.EventVariant.GIFT_FLING_05,
		45: Events.EventVariant.GIFT_FLING_05,
		60: Events.EventVariant.GIFT_FLING_05,
		75: Events.EventVariant.GIFT_FLING_05,
		90: Events.EventVariant.GIFT_FLING_05,
		105: Events.EventVariant.GIFT_FLING_05,
	},
	"random": { "enabled": false },
}
var zen_endless := {
	"meteors": [
		{ "count": 2, "variant": Meteor.Variants.Variant.STANDARD },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_1 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_2 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_3 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_4 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_7 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_8 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_9 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_12 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_13 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_14 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_15 },
		{ "count": 2, "variant": Meteor.Variants.Variant.ST_16 },
		{ "count": 2, "variant": Meteor.Variants.Variant.BIG_0 },
		{ "count": 2, "variant": Meteor.Variants.Variant.BIG_1 },
		{ "count": 2, "variant": Meteor.Variants.Variant.BIG_3 },
		{ "count": 2, "variant": Meteor.Variants.Variant.BIG_4 },
		{ "count": 2, "variant": Meteor.Variants.Variant.BIG_5 },
		{ "count": 2, "variant": Meteor.Variants.Variant.BIG_6 },
	],
	"gun_variant": Gun.Variants.Variant.RED_LIGHT,
	"gun_repair": true,
	"track": 3,
	"time": 0,
	"time_wait": 15.0,
	"hearts": true,
	"wait_clear": true,
	"end_game": false,
	"cheat_play": false,
	"endless_splash": true,
	"show_donate": false,
	"show_review": false,
	"fortune_coef": 0.3,
	"next_level": Level.ZEN_START,
	"action_random": {
		"enabled": true,
		"amount": 24,
		"speed": 8,
		"interval": 0.1,
	},
	"action_boost": {
		"enabled": true,
		"boost": 5,
		"timeout": 15.0,
		"speed": 5,
	},
	"action_border": {
		"enabled": true,
		"timeout": 15.0,
		"speed": 6,
	},
	"action_drop": {
		"enabled": true,
		"amount": 180,
		"variants": {
			"yellow": { "amount": 5, "impulse": 800.0 },
			"red": { "amount": 5, "impulse": 700.0 },
			"blue": { "amount": 5, "impulse": 600.0 },
		},
		"interval_min": 0.04,
		"interval_max": 0.07,
		"animation": Drop.DropVariant.BLUE,
		"speed": 5,
	},
	"events": {
		1: Events.EventVariant.GIFT_RENEWAL,
		2: Events.EventVariant.GIFT_BOOST,
		3: Events.EventVariant.GIFT_BORDER,
		4: Events.EventVariant.GIFT_DROP,
		5: Events.EventVariant.GIFT_FLING,
		6: Events.EventVariant.GIFT_RANDOM,
		7: Events.EventVariant.UPGRADE_RED_STANDARD,
		8: Events.EventVariant.UPGRADE_RED_BLUE,
		9: Events.EventVariant.UPGRADE_RED_WHITE_BLUE,
		10: Events.EventVariant.UPGRADE_RED_BIG_BLUE,
		11: Events.EventVariant.UPGRADE_RED_GRAY,
		12: Events.EventVariant.UPGRADE_RED_SMALL_WHITE_BLUE,
		13: Events.EventVariant.UPGRADE_RED_SMALL_WHITE_BLUE_1,
		14: Events.EventVariant.UPGRADE_RED_SMALL_WHITE_BLUE_2,
		15: Events.EventVariant.UPGRADE_RED_YELLOW,
		16: Events.EventVariant.UPGRADE_RED_RED,
		17: Events.EventVariant.UPGRADE_RED,
		18: Events.EventVariant.UPGRADE_RED_LIGHT,
		19: Events.EventVariant.WAVE_ST_5,
		20: Events.EventVariant.WAVE_ST_6,
		21: Events.EventVariant.WAVE_ST_10,
		22: Events.EventVariant.WAVE_ST_11,
		23: Events.EventVariant.WAVE_BIG_2,
		24: Events.EventVariant.WAVE_BIG_7,
	},
	"random": {
		"enabled": true,
		"meteors": {
			"variants": { "min": 5, "max": 8 },
			"change_interval": { "min": 30.0, "max": 60.0 },
			"mode": RndMeteorsMode.RANDOM,
		},
		"events": {
			"interval": { "min": 20.0, "max": 80.0, },
			"list": range(1, 24),
			"mode": RndEventsMode.RANDOM,
		},
	},
}


func get_level(level) -> Dictionary:
	match level:
		Level.TEST:
			return test
		Level.NEWBIE:
			return newbie
		Level.NEWBIE_1:
			return newbie_1
		Level.NEWBIE_2:
			return newbie_2
		Level.MIDDLE:
			return middle
		Level.MIDDLE_RELAX:
			return middle_relax
		Level.MIDDLE_EASY:
			return middle_easy
		Level.END:
			return end
		Level.END_MIDDLE:
			return end_middle
		Level.END_END:
			return end_end
		Level.ZEN_START:
			return zen_start
		Level.ZEN_MIDDLE:
			return zen_middle
		Level.ZEN_NEXT:
			return zen_next
		Level.ZEN_ENDLESS:
			return zen_endless
		_:
			return newbie
