extends Object


signal on_timeout

var _tasks := {}


func tick(delta: float) -> void:
	var for_remove := []
	for task in _tasks.values():
		if task.time == -1:
			continue
		task.time -= delta
		if task.time <= 0:
			for_remove.append(task.timeout)
			emit_signal("on_timeout", task.data)
	for timeout in for_remove:
		_tasks.erase(timeout)


func add_task(timeout: float, data) -> void:
	_tasks[timeout] = { "data": data, "time": timeout, "timeout": timeout }


func clear() -> void:
	_tasks.clear()
