extends Object


var _music_idx: int = AudioServer.get_bus_index("Music")


func tick(delta: float, timeout: float) -> void:
	var orig_vol: float = db2linear(Global.store.get_property(Global.Store.Property.VOLUME_MUSIC))
	var volume: float = db2linear(AudioServer.get_bus_volume_db(_music_idx))
	if volume == 0:
		return
	volume -= (orig_vol / timeout / 60) * (delta * 60)
	if volume < 0:
		volume = 0
	AudioServer.set_bus_volume_db(_music_idx, linear2db(volume))


func reset() -> void:
	var volume: float = Global.store.get_property(Global.Store.Property.VOLUME_MUSIC)
	AudioServer.set_bus_volume_db(_music_idx, volume)
