extends VBoxContainer


onready var _fps_label: Label = $FPSLabel
onready var _pfps_label: Label = $PFPSLabel
onready var _obj_label: Label = $OBJLabel
onready var _mem_label: Label = $MEMLabel


func _process(_delta: float) -> void:
	if visible:
		var physic_delta = get_physics_process_delta_time()
		var ips = Engine.iterations_per_second
		var pfps = round(ips / (physic_delta * ips))
		var obj_count = Performance.get_monitor(Performance.OBJECT_COUNT)
		var res_count = Performance.get_monitor(Performance.OBJECT_RESOURCE_COUNT)
		var orp_count = Performance.get_monitor(Performance.OBJECT_ORPHAN_NODE_COUNT)
		_fps_label.text = "FPS: " + str(Engine.get_frames_per_second())
		_pfps_label.text = "PFPS: " + str(pfps)
		_obj_label.text = "OBJ: " + str(obj_count) + " / " + str(res_count) + " / " + str(orp_count)
		if OS.is_debug_build():
			var s_mem = round(Performance.get_monitor(Performance.MEMORY_STATIC) / pow(1024, 2))
			var d_mem = round(Performance.get_monitor(Performance.MEMORY_DYNAMIC) / pow(1024, 2))
			var v_mem = round(
					Performance.get_monitor(Performance.RENDER_VIDEO_MEM_USED) / pow(1024, 2)
			)
			var text = "MEM: " + str(s_mem) + " / " + str(d_mem) + " / " + str(v_mem) + " MiB"
			_mem_label.text = text
