extends AnimatedSprite


const _MIDDLE_FRAME := 30

export var blink_amount := 3

var _is_ready := false
var _blink := 0

onready var _timer: Timer = $Timer


func _ready() -> void:
	_is_ready = true


func _exit_tree() -> void:
	_timer.paused = true


func _enter_tree() -> void:
	if not _is_ready:
		return
	_timer.paused = false


func play_animation() -> void:
	frame = 0
	show()
	play("default")


func _on_SplashSprite_animation_finished() -> void:
	hide()


func _on_SplashSprite_frame_changed() -> void:
	if frame == _MIDDLE_FRAME:
		stop()
		hide()
		_timer.start()


func _on_Timer_timeout() -> void:
	var toggle_val: bool = !visible
	if toggle_val:
		frame = _MIDDLE_FRAME
		_blink += 1
	if _blink >= blink_amount:
		_blink = 0
		frame = _MIDDLE_FRAME + 1
		_timer.stop()
		play("default")
	visible = toggle_val
