extends Object


const _CONFIG_PATH := "user://asteroids_letter.conf"
const _LIMIT_MS := 10 * 60 * 60 * 1000

var _time_ms := 1


func _init() -> void:
	_load()


func can_show_letter_button() -> bool:
	if _time_ms >= _LIMIT_MS:
		return true
	else:
		return false


func save() -> void:
	var config = ConfigFile.new()
	config.set_value("letter", "time", _time_ms + Time.get_ticks_msec())
	config.save(_CONFIG_PATH)


func _load() -> void:
	var config = ConfigFile.new()
	if config.load(_CONFIG_PATH) != OK:
		return
	_time_ms = config.get_value("letter", "time", 1)
