extends Control


var _first := true

onready var _vbox: VBoxContainer = $ScrollContainer/VBoxContainer
onready var _label: Label = $ScrollContainer/VBoxContainer/Label
onready var _edit: LineEdit = $ScrollContainer/VBoxContainer/LineEdit
onready var _popup: PopupPanel = $CanvasLayer/PopupPanel


func _ready() -> void:
	_edit.connect("copied_to_clipboard", self, "_copied_to_clipboard")
	_edit.connect("mouse_exited", self, "_edit_mouse_exited")
	_edit.connect("focus_exited", self, "_edit_mouse_exited")
	for currency in Global.donate.get_currencies():
		add_currency(currency.name, currency.addr)


func add_currency(name: String, addr: String) -> void:
	if _first:
		_label.text = name
		_edit.text = addr
		_first = false
		return
	var _new_label: Label = _label.duplicate()
	var _new_edit: LineEdit = _edit.duplicate(DUPLICATE_SCRIPTS | DUPLICATE_SIGNALS)
	_new_label.text = name
	_new_edit.text = addr
	_new_edit.connect("copied_to_clipboard", self, "_copied_to_clipboard")
	_new_edit.connect("mouse_exited", self, "_edit_mouse_exited")
	_new_edit.connect("focus_exited", self, "_edit_mouse_exited")
	_vbox.call_deferred("add_child", _new_label)
	_vbox.call_deferred("add_child", _new_edit)


func _copied_to_clipboard() -> void:
	_popup.popup()


func _edit_mouse_exited() -> void:
	_popup.hide()


func _on_BackButton_pressed() -> void:
	Global.goto_scene("res://menu/main_menu.tscn")


func _on_VBoxContainer_focus_entered() -> void:
	_popup.hide()
