extends GutTest


func test_bullets() -> void:
	var bullet_vars = load("res://entity/bullet/variants.gd")
	bullet_vars = bullet_vars.new()
	for bullet_key in Bullet.Variants.Variant:
		var bullet_val = Bullet.Variants.Variant[bullet_key]
		var vars = bullet_vars.get_vars(bullet_val)
		assert_has(vars, "impulse_value", bullet_key)
		assert_has(vars, "hp", bullet_key)
		assert_has(vars, "damage", bullet_key)
		assert_has(vars, "mass", bullet_key)
		assert_has(vars, "animation", bullet_key)
		assert_typeof(vars.impulse_value, TYPE_REAL, bullet_key + " impulse_value")
		assert_typeof(vars.hp, TYPE_REAL, bullet_key + " hp")
		assert_typeof(vars.damage, TYPE_REAL, bullet_key + " damage")
		assert_typeof(vars.mass, TYPE_REAL, bullet_key + " mass")
		assert_typeof(vars.animation, TYPE_STRING, bullet_key + " animation")
		assert_file_exists("res://entity/bullet/anim/" + vars.animation + ".tres")
	bullet_vars.free()


func test_guns() -> void:
	pass


func test_meteors() -> void:
	pass


func test_fragments() -> void:
	pass


func test_levels() -> void:
	pass


func test_events() -> void:
	pass


func test_cheats() -> void:
	var cheats = load("res://game/gd/cheats.gd")
	cheats = cheats.new()
	var keys: Array = cheats._cheats.keys()
	for key in keys:
		assert_eq(keys.count(key), 1, str(key) + " only one")
	cheats.free()
